<?php
/*
 * Domain CMS
 * Copyright @2019 Hito
 *
 * Feed功能实现
 */

$feedtype = get_query_var('feed');
$feed_use_excerpt = (bool) get_option('feed_use_excerpt');
$sitename = get_option('sitename');
$rssurl = get_dminfo('rss_url');
$atomurl = get_dminfo('atom_url');
$sitedescription = get_option('sitedescription');
$homeurl = home_url(true);
$dmversion = get_dm_version();
$lastupdate = '';

$feedxml = '';
while(have_posts()){
    the_post();
    $post_id = get_the_ID();
    $post_title = get_the_title();
    $post_subtitle = get_the_subtitle();
    $post_link = get_the_permalink();
    $surl = $homeurl.'?p='.$post_id;
    $post_author = get_the_author();
    $post_category = get_the_category()[0];
    $post_date = get_the_time();
    $post_modified = get_the_modified_time();
    $post_excerpt = get_the_excerpt();
    $post_content = get_the_content();

    $post_content_rss = '';
    $post_content_atom = '';
    if($feed_use_excerpt == false){
        $post_content_rss = '<content:encoded><![CDATA['.get_the_content().']]></content:encoded>';
        $post_content_atom = '<content type="html"><![CDATA['.get_the_content().']]></content>';
    }

    if($lastupdate == '' || $lastupdate < $post_modified)
        $lastupdate = $post_modified;

    $catname = esc_html($post_category->cat_name);

    $catlink = get_category_link($post_category);
    $authorlink = get_author_link(get_post());

    if(substr($post_link, 0, 4) != 'http')
        $post_link = home_url(true). substr($post_link, 1);

    if(substr($authorlink, 0, 4) != 'http')
        $authorlink = home_url(true). substr($authorlink, 1);

    if(substr($catlink, 0, 4) != 'http')
        $catlink = home_url(true). substr($catlink, 1);

    if(has_thumbnail())
        $figures = '<img src="'.get_the_thumbnail().'">';
    else
        $figures = '';
    $gallery = get_post_images('gallery');
    if(!empty($gallery)){
        foreach($gallery as $img){
            $figures .= sprintf("\n".'<img src="%s">', $img->url);
        }
    }

    $navs = '';
    $cs = get_categories();
    foreach($cs as $c){
        $navs .= sprintf("\n".'<a href="%s">%s</a>', $c->get_permalink(), $c->cat_name);
    }
    $navs = trim($navs);


    if($feedtype == 'rss'){
        $feedxml .= sprintf('
<item turbo="true">
    <title>%s</title>
    <link>%s</link>
    <category>%s</category>
    <pubDate>%s</pubDate>
    <author>%s</author>
    <turbo:content>
        <![CDATA[
            <header>
                <h1>%s</h1>
                <h2>%s</h2>
                <figure>
                    %s
                </figure>
                <menu>
                    %s
                </menu>
            </header>
            %s
        ]]>
    </turbo:content>
</item>', esc_html($post_title), $post_link,  $catname, date(DATE_RFC2822, $post_date), $post_author, $post_title, $post_subtitle, $figures, $navs, $post_content);
    }elseif($feedtype == 'atom'){
        $feedxml .= sprintf('
<entry>
    <title type="html">%s</title>
    <link rel="alternate" type="text/html" href="%s"/>
    <author>
        <name>%s</name>
        <uri>%s</uri>
    </author>
    <id>%s</id>
    <published>%s</published>
    <updated>%s</updated>
    <category scheme="%s" term="%s"/>
    <summary type="html">%s</summary>
    %s
</entry>',esc_html($post_title), $post_link, $post_author, $authorlink, $surl, date(DATE_RFC3339, $post_date), date(DATE_RFC3339, $post_modified), $catlink, esc_html($catname), esc_html($post_excerpt), $post_content_atom);
    }
}


if($feedtype == 'rss'){

    $feedheader = '<rss xmlns:yandex="http://news.yandex.ru" xmlns:media="http://search.yahoo.com/mrss/" xmlns:turbo="http://turbo.yandex.ru" version="2.0">';

    $feedheader .= sprintf('
    <channel>
    <title>%s</title>
    <link>%s</link>
    <description>%s</description>
    <language>ru</language>
    <turbo:analytics type="Google" id="UA-75819314-8"></turbo:analytics>
    <lastBuildDate>%s</lastBuildDate>
    <generator>Domai CMS %s</generator>', esc_html($sitename), $homeurl, esc_html($sitedescription), date(DATE_RFC2822, $lastupdate), $dmversion);

    echo sprintf("%s%s\r\n%s",$feedheader, $feedxml,'</channel></rss>');

}elseif($feedtype = 'atom'){

    $feedheader = '<?xml version="1.0" encoding="UTF-8"?><feed xmlns="http://www.w3.org/2005/Atom">';

    $feedheader .= sprintf('
    <title type="text">%s</title>
    <link href="%s"/>
    <link href="%s" rel="self"/>
    <id>%s</id>
    <updated>%s</updated>
    <generator uri="https://project.hitoy.org/domai-cms/" version="%s">Domai CMS</generator>', esc_html($sitename), $homeurl, $atomurl, $atomurl, date(DATE_RFC3339, $lastupdate), $dmversion);

    echo sprintf("%s%s\r\n%s",$feedheader, $feedxml,'</feed>');

}
